import std/htmlparser
import std/xmltree
import std/strtabs

type 
  Descriptor* = object
    name* : string
    html_tag* : string
    html_context_tag* : string
    contains_string* : string
    attrs* : string
type
  Entry* = object
    name* : seq[Descriptor]

proc getEntryFromHtml*(entry : Entry, node : XmlNode) =
  echo(entry.name[0])
  
  let context = node.findAll(entry.name[0].html_context_tag)
  for a in context:
    
    let subContext = a.findAll(entry.name[0].html_tag)
    for b in subContext:
      echo(b)
      if entry.name[0].attrs != "":
        if b.attrs.hasKey(entry.name[0].attrs):
          echo("found key")
          if entry.name[0].contains_string != "":
            echo(" and string")
            #check if b contains contains_string
            #return function
      if entry.name[0].contains_string != "":
        echo("found string")
        #check if b contains contains_string
        #return function


proc test() =
  var htmlnode : XmlNode
  var str_html : string
  var entry: Entry
  entry.name[0] = Descriptor(html_tag : "p", contains_string : "test_container")
  echo entry

  htmlnode = parseHtml(str_html)
  entry.getEntryFromHtml(htmlnode)

#test()
